<?php
define("DB_CONFIG_FILE",    "{DB_CONFIG_FILE}");
define("FORM_CONFIG_FILE",  "{FORM_CONFIG_FILE}");
define("CONNECTOR_FILE",    "{CONNECTOR_FILE}");
define("IS_CONFIGURED",     "{NOT_COFIGURED}");
define("LOG_FILE",          "{LOG_FILE}");

if (!file_exists(DB_CONFIG_FILE)) {
  	require_once("langs/english.php");
} else {
	$conf_file_ini = parse_ini_file(DB_CONFIG_FILE, true);
  	require_once('langs/'.$conf_file_ini["language"]["language_file"]);
}

function make_connector($filename, $config_file, $form_config_file)
{
  $conn = array();
  $ini_array = array_merge(parse_ini_file($config_file, true), parse_ini_file($form_config_file, true));

  $k=1;
  $fields = array();
  while (array_key_exists($key = "field_".$k, $ini_array))
  {
    $fields[]= $ini_array[$key];
    $k++;
  }
  
  sksort($fields, "order", true);
  
  $conn[]= '<?php';
  $conn[]= 'require("db.php");';
  $conn[]= 'require("codebase/dhtmlxConnector/grid_connector.php");';
  if($ini_array["database"]["db"]!='MySQL') $conn[]= 'require("codebase/dhtmlxConnector/db_'.strtolower($ini_array["database"]["db"]).'.php");';  
  $conn[]= '';
  $conn[]= sprintf('$res = DB::connect("%s", "%s", "%d", "%s", "%s", "%s");', $ini_array["database"]["db"], $ini_array["database"]["db_host"], $ini_array["database"]["db_port"], $ini_array["database"]["db_user"], $ini_array["database"]["db_pass"], $ini_array["database"]["db_name"]);
  $conn[]= '';
  $conn[]= '$access_key = "'.$ini_array["access_key"]["access_key"].'";';
  $conn[]= '';
  $conn[]= '$grid = new GridConnector($res, "'.$ini_array["database"]["db"].'");';
  $conn[]= '$grid->enable_log("'.LOG_FILE.'",true);';
  $conn[]= '';
  $conn[]= 'function grid_header()';
  $conn[]= '{';
  $conn[]= '  if (!isset($_GET["posStart"]))';
  $conn[]= '        echo \'<head>';
  
  $filters   = array();
  $colls     = array();
  $db_fields = array();
  $need_attach = false;
  $j = 0;
  
  $width = floor (100 / count($fields));
  $last_width = 100 - (count($fields)-1) * $width;
  foreach ($fields as $field)
  {
      $db_fields[]= $field["field_name"];
      $conn[]='                <column width="'.(($j == sizeof($fields)-1) ? $last_width : $width).'" type="'.$field["type"].'" align="left" sort="'.$field["sort"].'"><![CDATA['.str_replace(',','\,',$field["title"]).']]></column>';
      
      if ($field["filter"]!="na")
      {
        $filters[]= $field["filter"];
        $need_attach = true;
      }
      else
      {
        $filters[]= "";      
      }

      if (($field["type"] == "co") || $field["filter"] == "#connector_select_filter")
      {
        $colls[]= $j;
      }
      $j++;
  }
  if ($need_attach)
  {
    $conn[]= '                <afterInit><call command="attachHeader"><param>'.join(",",$filters).'</param></call></afterInit>';
  }
  $conn[]= '                <settings><colwidth>%</colwidth></settings>';
  $conn[]= '              </head>\';';
  $conn[]= '}';
  $conn[]= '';
  $conn[]= 'if (isset($_GET["header"]))';
  $conn[]= '{';
  $conn[]= '  $grid->event->attach("beforeOutput","grid_header");';
  if (count($colls))
  {
    $conn[]= '  $_GET["dhx_colls"]= "'.join(",",$colls).'";';
  }
  $conn[]= '}';
  $conn[]= '$key = isset($_GET["key"]) ? $_GET["key"] : "";';
  $conn[]= 'if ($key!==$access_key)';
  $conn[]= '{';
  $conn[]= '  $grid->access->deny("update");';
  $conn[]= '  $grid->access->deny("insert");';
  $conn[]= '  $grid->access->deny("delete");';
  $conn[]= '}';
  $conn[]= '';
  $conn[]= '$grid->dynamic_loading(100);';
  if($ini_array["database"]["db"]=='Oracle') $conn[]= '$grid->sql->sequence("'.$ini_array["autoincrement_field"]["sequence"].'.nextVal");';
  $conn[]= '$grid->render_table("'.$ini_array["db_table"]["db_table"].'","'.$ini_array["autoincrement_field"]["autoincrement_field"].'","'.join(",",$db_fields).'");';
  $conn[]= '?>';
  
  if ($f = fopen($filename, "w"))
  {
    fwrite($f, join("\n",$conn));
    fclose($f);
  }
  else
  {
    return false;
  }
}

function dbg ($obj)
{
  print "<pre>";
  print_r ($obj);
  print "</pre>";
}

function full_del ($dest, $selfRemove = false, $ext = '') 
{
  if(!$dh = @opendir ($dest))  return; 
  while (false !== ($obj = readdir ($dh))) 
  {
    if($obj == '.' || $obj == '..' || (is_file($dest."/".$obj) && $ext != '' && $ext != strrchr($obj, '.'))) continue;
    if (is_file($dest . '/' . $obj))
    {
      @unlink($dest . '/' . $obj);
    }
    else
    {
      full_del($dest . '/' . $obj, true, $ext);
    }
  }
  closedir($dh);
  if ($selfRemove) return @rmdir($dest);
}

function sksort(&$array, $subkey = "id", $sort_ascending = false) 
{
  if (count($array)) $temp_array[key($array)] = array_shift($array);
  foreach($array as $key => $val)
  {
      $offset = 0;
      $found  = false;
      foreach($temp_array as $tmp_key => $tmp_val)
      {
          if(!$found and strtolower($val[$subkey]) > strtolower($tmp_val[$subkey]))
          {
              $temp_array = array_merge((array) array_slice($temp_array,0,$offset), array($key => $val), array_slice($temp_array,$offset));
              $found = true;
          }
          $offset++;
      }
      if(!$found) $temp_array = array_merge($temp_array, array($key => $val));
  }
  if ($sort_ascending) $array = array_reverse($temp_array);
  else $array = $temp_array;
}

if (IS_CONFIGURED != "YES")
{
  die(LOC_FORM_TEMP_ERR1);
}

if (!file_exists(FORM_CONFIG_FILE))
{
  die(printf(LOC_FORM_TEMP_ERR2,FORM_CONFIG_FILE));
}

if (!file_exists(DB_CONFIG_FILE))
{
  die(printf(LOC_FORM_TEMP_ERR2,DB_CONFIG_FILE));
}

if (!file_exists(DB_CONFIG_FILE) || !file_exists(CONNECTOR_FILE) || (filemtime(DB_CONFIG_FILE) > filemtime(CONNECTOR_FILE)) || (filemtime(FORM_CONFIG_FILE) > filemtime(CONNECTOR_FILE)))

{
    make_connector(CONNECTOR_FILE, DB_CONFIG_FILE, FORM_CONFIG_FILE);
}
// Get public pages from config
$conf_file_ini = parse_ini_file(DB_CONFIG_FILE, true);
$f_pages = $conf_file_ini["public_pages"]["public_pages"];
$f_pages = explode(',', $f_pages);
if(count($f_pages)&&$f_pages[0]!='')
{
	foreach($f_pages as $f_page)
	{
		if($f_page!=basename(__FILE__))
		{
			$f_page_conf = 'conf/'.basename($f_page, ".php").'.ini';
			$ini = parse_ini_file($f_page_conf, true);
			$favarite_page = array('title' => $ini["grid_title"]["grid_title"],
									'file' => $f_page);
			$js_pages[] = "Array('".$favarite_page['file']."', 'obj', '".$favarite_page['title']."')";
		}
	}
	$js_pages = @implode(',',$js_pages);
}
?>
<html>
<head>
	<title>{GRID_TITLE}</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <!--  Common  -->
    <script src="codebase/dhtmlxcommon.js"></script>

    <!--  Layout  -->
    <script src="codebase/dhtmlxLayout/dhtmlxlayout.js"></script>
    <script src="codebase/dhtmlxLayout/dhtmlxcontainer.js"></script>
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxLayout/dhtmlxlayout.css">
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxLayout/skins/dhtmlxlayout_dhx_blue.css">
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxLayout/skins/dhtmlxlayout_dhx_black.css">
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxLayout/skins/dhtmlxlayout_dhx_skyblue.css">
    
    <!--  Toolbar  -->
    <script src="codebase/dhtmlxToolbar/dhtmlxtoolbar.js"></script>
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxToolbar/skins/dhtmlxtoolbar_dhx_blue.css">
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxToolbar/skins/dhtmlxtoolbar_dhx_black.css">
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxToolbar/skins/dhtmlxtoolbar_dhx_skyblue.css">
    
    <!--  Grid  -->
    <script src="codebase/dhtmlxGrid/dhtmlxgrid.js"></script>
    <script src="codebase/dhtmlxGrid/dhtmlxgridcell.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_srnd.js"></script>
    <script src="codebase/grid_to_pdf/dhtmlxgrid_pdf.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_filter.js"></script>
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxGrid/dhtmlxgrid.css">    
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxGrid/skins/dhtmlxgrid_dhx_blue.css">
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxGrid/skins/dhtmlxgrid_dhx_black.css">
    <link rel="stylesheet" type="text/css" href="codebase/dhtmlxGrid/skins/dhtmlxgrid_dhx_skyblue.css">

    <!--
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_deprecated.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_drag.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_keymap_access.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_keymap_excel.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_keymap_extra.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_nxml.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_selection.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_start.js"></script>
    <script src="codebase/dhtmlxGrid/ext/dhtmlxgrid_validation.js"></script>
    -->
    
    <!--  Dataprocessor  -->
    <script src="codebase/dhtmlxDataProcessor/dhtmlxdataprocessor.js"></script>
    <!-- <script src="codebase/dhtmlxDataProcessor/dhtmlxdataprocessor_debug.js"></script> -->
    
    <!--  Connector -->
    <script src="codebase/dhtmlxConnector/connector.js"></script>
  
    <style>
     html, body 
     {
        width: 100%;
        height: 100%;
        margin: 0px;
        overflow: auto;
     }
    </style>
    <script>
       function get_key()
       {
         var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
         for(var i = 0; i < hashes.length; i++)
         {
           hash = hashes[i].split('=');
           if (hash[0] == "key") return hash[1];
         }
         return "";
       }
    
       function doOnLoad() 
       {
          
          var key = get_key();
          var dhxLayout = new dhtmlXLayoutObject(document.body, "1C", "dhx_skyblue");

          //dhxLayout.cells("a").setText("Grid");
          dhxLayout.cells("a").hideHeader();
          
          if (key!="")
          {
            var dhxToolbar = dhxLayout.cells("a").attachToolbar();
            dhxToolbar.addButton("btn_add",  1, "<?=LOC_BTN_ADD?>", "files/add.gif");
            dhxToolbar.addSeparator("sep", 2);            
            dhxToolbar.addButton("btn_del",  3, "<?=LOC_BTN_DEL?>", "files/delete.gif");
            dhxToolbar.addSeparator("sep", 4);
            dhxToolbar.addButton("btn_edit", 5, "<?=LOC_BTN_EDIT?>", "files/edit.gif");
			dhxToolbar.addSeparator("sep", 6);
            dhxToolbar.addButton("btn_print", 7, "<?=LOC_BTN_PRINT?>", "files/print.gif");
			
			<?php if(isset($js_pages)):?>
			dhxToolbar.addSeparator("sep", 8);
			var favPages = Array(<?php echo $js_pages?>);
			dhxToolbar.addButtonSelect("pages", 9, "<?=LOC_BTN_PAGES?>", favPages, "files/pages.gif");
			<?php endif;?>

            dhxToolbar.base.onclick=function(e){e=e||event;e.cancelBubble=true;}
          
            dhxToolbar.attachEvent("onClick", function(id) 
            {
                 if (id == "btn_add") {
                    var id=dhxGrid.uid(); 
                    dhxGrid.addRow(id,'',0); 
                    dhxGrid.showRow(id);
                 } else if (id == "btn_del") {
                    dhxGrid.deleteSelectedRows();
                 } else if (id == "btn_edit") {
                    dhxGrid.editCell();
                 } else if (id == "btn_print") {
					dhxGrid.toPDF('codebase/grid_to_pdf/generate.php');
					
				 } else if (id == "pages"){
				 } else {
					 var listOptionId = dhxToolbar.getListOptionSelected('pages');
					 window.location.href = listOptionId+'?key='+key;
				 }
            });
          }
		  else
		  {
			  var dhxToolbar = dhxLayout.cells("a").attachToolbar();
			  dhxToolbar.addButton("btn_print", 1, "<?=LOC_BTN_PRINT?>", "files/print.gif");
			  dhxToolbar.addSeparator("sep", 2);

			  <?php if(isset($js_pages)):?>
			  var favPages = Array(<?php echo $js_pages?>);
			  dhxToolbar.addButtonSelect("pages", 3, "<?=LOC_BTN_PAGES?>", favPages, "files/pages.gif");
			  
			  dhxToolbar.base.onclick=function(e){e=e||event;e.cancelBubble=true;}
			  <?php endif;?>
			  
			  dhxToolbar.attachEvent("onClick", function(id) 
			  {
				  if (id == "btn_print") {
					dhxGrid.toPDF('codebase/grid_to_pdf/generate.php');
				   } else if (id == "pages"){
				   } else {
					   var listOptionId = dhxToolbar.getListOptionSelected('pages');
					   window.location.href = listOptionId;
				   }
			  });
		  }
          
          var dhxGrid = dhxLayout.cells("a").attachGrid();
          dhxGrid.setImagePath("{QT_URL}codebase/dhtmlxGrid/imgs/");
          dhxGrid.setSkin('dhx_skyblue');
          if (!key)
          	dhxGrid.attachEvent("onEditCell",function(){
          		return false;
			})
          dhxGrid.enableSmartRendering(true);

          dhxGrid.loadXML("{CONNECTOR_FILE}?header=true&key=" + key, function()
          {
             dhxGrid.xmlFileUrl = "{CONNECTOR_FILE}?key=" + key;
          });
          
          dhxGrid.init();
          
          var dp = new dataProcessor("{CONNECTOR_FILE}?key=" + key);
          dp.init(dhxGrid);
      }
    </script>
</head>
<body onLoad="doOnLoad();">
</body>
</html>
