<?php
session_start ();

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Datum aus Vergangenheit
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); 


require_once("functions.php");
require_once("./../db.php");


$sort_values   = array("not available"  => "na",
                       "server-side"    => "connector");
                        
$filter_values = array("not available"  => "na",
                       "text"           => "#connector_text_filter",
                       "select"         => "#connector_select_filter");
                        
$type_values   = array("read only"      => "ro",
                       "editable"       => "ed",
                       "checkbox"       => "ch",
                       "selectbox"      => "co");

$reserved_names = array("index", "form_template");
                       
$config_dir    = "../conf/";
$config_file   = $config_dir."db_config.ini";

$form_template = "../form_template.php";

$grid_root_page = "http://".$_SERVER["HTTP_HOST"].$_SERVER["PHP_SELF"];
$grid_root_page = preg_replace("/\/[^\/]+\/index\.php$/", "", $grid_root_page)."/";

$grid_admin_page = $grid_root_page;

if (!file_exists($config_file)) {
	$lang = $_SESSION['lang'];
	$_SESSION = array();
  	$_SESSION["step"] = 1;
	
	if ($lang) $_SESSION['lang'] = $lang;
	else $_SESSION['lang'] = 'english.php';
	
	if ($_GET['lang']&&file_exists('../langs/'.$_GET['lang'].'.php')) {
		$_SESSION['lang'] = $_GET['lang'].'.php';
	}
  	require_once("../langs/".$_SESSION["lang"]);
} else {
	$conf_file_ini = parse_ini_file($config_file, true);
  	require_once('../langs/'.$conf_file_ini["language"]["language_file"]);
}
	

$title = LOC_INSTALL_TITLE;

if (isset($_GET["form_conf"]))
{
    $_SESSION = array();
    $_SESSION["step"] = 2;
}

if (!isset($_SESSION["step"]))
{
  die();
}


switch ($_SESSION["step"])
{
    //==============================================================================================
    // STEP 1 - DB configuration
    //==============================================================================================
    
    case "1":
		  // Default values
		  $dbs = DB::getPossibleDB();
		  if (!isset($_SESSION["db"])&&count($dbs)) $_SESSION["db"] = reset($dbs);
		  elseif (count($dbs)==0) $error_msg = LOC_INSTALL_ERR4;
		  
		  $default_DBs_settings = DB::getDefDBSettings();
          if (!isset($_SESSION["db_host"])) $_SESSION["db_host"] = "localhost";
          if (!isset($_SESSION["db_port"])) $_SESSION["db_port"] = "3306";
          if (!isset($_SESSION["db_name"])) $_SESSION["db_name"] = "sampledb";
          if (!isset($_SESSION["db_user"])) $_SESSION["db_user"] = "root";
          if (!isset($_SESSION["db_pass"])) $_SESSION["db_pass"] = "";
		  
          if (isset($_POST["next"]))
          {
			$_SESSION["db"] = $_POST["db"];
            $_SESSION["db_host"] = $_POST["db_host"];
            $_SESSION["db_port"] = $_POST["db_port"];
            $_SESSION["db_name"] = $_POST["db_name"];
            $_SESSION["db_user"] = $_POST["db_user"];
            $_SESSION["db_pass"] = $_POST["db_pass"];
			

			$error_msg = '';
            $_SESSION["tables"] = DB::getTables($error_msg);
			
            $phpversion = phpversion(); 
            $error_msg.= ($phpversion[0]!="5") ? LOC_INSTALL_ERR5:"";


            $_SESSION["access_key"] = rand_str(15);

            if ($error_msg=="") 
            {
				$result = save_cofig($config_file, prepare_global_config_data());
            	if ($result!="") {
              		$error_msg.= $result."<br>";            
            	} else {
					$_SESSION["step"] = "1.1";  // NEXT STEP
					header('Location: index.php');
					die();
				}
            }
          }

		  

          $content = '<div id="content_step_1">';
          $content.= '<form action="index.php" method="POST">';
          $content.= '<table cellpadding="0" cellspacing="0">
          <tr><td class="first_td" width="140">&nbsp;</td><td><ul id="langs">';
			$lang_files = glob('../langs/*.php');
			foreach($lang_files as $lang_file) {
				$content.= '<li '.((basename($lang_file)==$_SESSION['lang'])?'class="selected"':'').'><a href="index.php?lang='.basename($lang_file,'.php').'" title="'.ucfirst(basename($lang_file,'.php')).'"><img src="../files/flag_'.basename($lang_file,'.php').'.gif" alt="'.ucfirst(basename($lang_file,'.php')).'" /></a></li>';
			}
		  $content.= '</ul><div class="message">'.LOC_DB_CONFIG.'</div><div style="clear:both"></div></td>
	      </tr>
          <tr>
		  	<td class="first_td" valign="top">'.LOC_DB.':</td>
		  	<td>
				<select id="db" name="db">';
					foreach($dbs as $db) $content.= '<option value="'.$db.'" '.(($_SESSION["db"]==$db)? 'selected="selected"' : '').'>'.$db.'</option>';
		  $content.= '</select>
			</td>
		  </tr>
		  <tr>
            <td class="first_td" valign="top">'.LOC_DB_HOST.':</td>
            <td>
                <input class="input" id="db_host" name="db_host" value="'.$_SESSION["db_host"].'" type="text"><span style="padding: 0 4;">:</span><input class="input" id="db_port" name="db_port" value="'.$_SESSION["db_port"].'" type="text">
                <span class="hint">'.LOC_DB_HOST_HINT.'</span>
            </td>
          </tr>
          <tr id="db_name_line">
            <td class="first_td" valign="top">'.LOC_DB_NAME.':</td>
            <td>
              <input class="input" id="db_name" name="db_name" value="'.$_SESSION["db_name"].'" type="text">
              <span class="hint">'.LOC_DB_NAME_HINT.'</span>
            </td>
          </tr>
          <tr><td class="first_td" valign="top">'.LOC_DB_USER.':</td><td><input class="input" id="db_user" name="db_user" value="'.$_SESSION["db_user"].'" type="text"></td></tr>
          <tr><td class="first_td" valign="top">'.LOC_DB_PASS.':</td><td><input class="input" name="db_pass" value="'.$_SESSION["db_pass"].'" type="password"></td></tr>';
          
          if ($error_msg!="")
          {
            $content.='<tr class="error_row"><td class="first_td"><div>'.LOC_ERROR.':</div></td><td><div class="error_msg"><div>'.$error_msg.'</div></div></td></tr>';
          }
          
          $content.= '<tr class="button-row"><td class="first_td">&nbsp;</td><td>'.button("continue").'</td></tr></table>';
          $content.= '</form></div>';
    		
		  $script =  "window.onload = function(){
						  document.getElementById('db').onchange = changeDefaultSettings;
					  }
					  function changeDefaultSettings(){
						  var db = document.getElementById('db').value;
						  var defValues = ".json_encode($default_DBs_settings).";
						  document.getElementById('db_port').value = defValues[db].db_port;
						  document.getElementById('db_name').value = defValues[db].db_name;
						  document.getElementById('db_user').value = defValues[db].db_user;
						  if (db=='Oracle') document.getElementById('db_name_line').style.display = 'none';
						  else document.getElementById('db_name_line').style.display = '';
					  }";
	
    break;


    
    
    //==============================================================================================
    // STEP 1.1 - message
    //==============================================================================================

    case "1.1":

          if (isset($_POST["next"]))
          {
    

            if ($error_msg=="") 
            {
               header('Location: index.php?form_conf=1&key='.$_SESSION["access_key"]);
               die();
            }
          }

          $content = '<div id="content_step_'.$_SESSION["step"].'">';
          $content.= '<form action="index.php" method="POST">';
          $content.= '<table cellpadding="0" cellspacing="0">
          <tr><td class="first_td" width="140">&nbsp;</td><td><div class="message">'.LOC_INSTALL_MSG1.'</div></td></tr>
          <tr><td class="first_td" ></td><td>'.LOC_GUEST_LINK.':<br><br>
          <a href="'.$grid_admin_page.'">'.$grid_admin_page.'</a><br><br>
          '.LOC_ADMIN_LINK.':<br><br>
          <a href="'.$grid_admin_page.'?key='.$_SESSION["access_key"].'">'.$grid_admin_page.'?key='.$_SESSION["access_key"].'</a><br><br>
          '.LOC_AUTH_KEY.' <b>'.$_SESSION["access_key"].'</b><br><br>
          '.LOC_INSTALL_MSG2.' "<b>'.str_replace("../","",$config_file).'</b>"
          <br><br>
          '.LOC_INSTALL_MSG3.'
          </td></tr>';
          if ($error_msg!="")
          {
            $content.='<tr class="error_row"><td class="first_td"><div>'.LOC_ERROR.':</div></td><td><div class="error_msg"><div>'.$error_msg.'</div></div></td></tr>';
          }
          $content.= '<tr class="button-row"><td class="but_first_td"></td><td>'.button("continue").'</td></tr></table>';
          $content.= '</table></form></div>';
    break;
    
    //==============================================================================================
    // STEP 2 | Define table
    //==============================================================================================
    
    case "2":
        $_SESSION["key"] = isset($_SESSION["key"]) ? $_SESSION["key"] : $_GET["key"];
        
        // READING INFO FROM CONFIG FILE:
        $ini_array = parse_ini_file($config_file, true);
		$_SESSION["db"] = $ini_array["database"]["db"];
        $_SESSION["db_host"] = $ini_array["database"]["db_host"];
        $_SESSION["db_port"] = $ini_array["database"]["db_port"];
        $_SESSION["db_name"] = $ini_array["database"]["db_name"];
        $_SESSION["db_user"] = $ini_array["database"]["db_user"];
        $_SESSION["db_pass"] = $ini_array["database"]["db_pass"];
        $_SESSION["access_key"] = $ini_array["access_key"]["access_key"];

        // CHECK AUTH
        if ($_SESSION["key"]!= $_SESSION["access_key"])
        {
          die();
        }
        
		$error_msg = '';
        $_SESSION["tables"] = DB::getTables($error_msg);
      
		$_SESSION["grid_title"] = isset($_POST["grid_title"])  ? $_POST["grid_title"]  : (isset($_SESSION["grid_title"])  ? $_SESSION["grid_title"] : "My GridView");
		$_SESSION["header"]     = isset($_POST["header"]) ? $_POST["header"] : (isset($_SESSION["header"]) ? $_SESSION["header"] : "");
        $_SESSION["footer"]     = isset($_POST["footer"]) ? $_POST["footer"] : (isset($_SESSION["footer"]) ? $_SESSION["footer"] : "");
        
        if (isset($_POST["next"]))
        {
          $_SESSION["db_table"]       = $_POST["db_table"];
          $_SESSION["use_all_fields"] = (isset($_POST["use_all_fields"])) ? "1" : "";
          $table = $_SESSION["db_table"];
          
          $_SESSION["fields"] = DB::getFields($error_msg);
		  if($_SESSION["db"] != 'Oracle') $_SESSION["auto_inc_field"] = DB::getAutoIncField($error_msg);
          
		  if(!empty($_POST["grid_title"]))
		  {
			  if(preg_match('/^[a-zA-Z0-9\-\_\s]+$/', $_POST["grid_title"])) $_SESSION["grid_title"] = $_POST["grid_title"];
			  else $error_msg.= LOC_INSTALL_ERR6."<br>";
		  } 
		  else
		  {
			 $error_msg.= LOC_INSTALL_ERR7."<br>";
		  }         
          // NEXT STEP
          if ($error_msg=="") 
          {
             if ($_SESSION["use_all_fields"]=="1")
             {
                  $_SESSION["fields_checked"][$table] = array();
                  for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
                  {
                    $_SESSION["fields_checked"][$table][$j] = 1;   // mark all fields as checked
                  }
                  $_SESSION["count_checked"][$table] = sizeof($_SESSION["fields"]);
                  $_SESSION["step"] = 4; // NEXT STEP (if all selected, skip step #3)
             }
             else
             {
                  $_SESSION["step"] = 3;
             }

             $_SESSION["step"] = ($_SESSION["use_all_fields"]=="1") ? 4 : 3;  
			 if($_SESSION["db"] == 'Oracle') $_SESSION["step"] = 2.1;
             header('Location: index.php');
             die();
          }
        }

        $table_select = '<select class="input" name="db_table">';
        for ($j=0; $j<sizeof($_SESSION["tables"]); $j++)
        {
          $table_select.= '<option '.($_SESSION["db_table"]==$_SESSION["tables"][$j] ? "selected=\"selected\"" : "").' value="'.$_SESSION["tables"][$j].'">'.$_SESSION["tables"][$j].'</option>';
        }
        $table_select.= '</select>';

        $content = '<div id="content_step_2">';
        $content.= '<form action="index.php" method="POST">';
        $content.= '<table cellpadding="0" cellspacing="0">
        <tr><td class="first_td" width="140">&nbsp;</td><td><div class="message">'.LOC_SEL_DB_TBL.'</div></td></tr>
        <tr><td class="first_td" valign="top">'.LOC_DEF_GRID_TITLE.':</td><td><input class="input" name="grid_title" type="text" value="'.$_SESSION["grid_title"].'" /></td></tr>';
		/*
        <tr><td class="first_td" valign="top">Define header:</td><td><input class="input" name="header" type="text" value="'.$_SESSION["header"].'" /></td></tr>
        <tr><td class="first_td" valign="top">Define footer:</td><td><input class="input" name="footer" type="text" value="'.$_SESSION["footer"].'" /></td></tr>
		*/
        $content.= '<tr><td class="first_td" valign="top">'.LOC_TABLES.':</td><td>'.$table_select.'</td></tr>
        <tr><td class="first_td" ></td><td><input class="checkbox" type="checkbox" name="use_all_fields" '.($_SESSION["use_all_fields"]=="1" ? "checked" : "").'>'.LOC_USE_ALL_FIELDS.'</td></tr>';
        if ($error_msg!="")
        {
          $content.='<tr class="error_row"><td class="first_td"><div>Error:</div></td><td><div class="error_msg"><div>'.$error_msg.'</div></div></td></tr>';
        }
        $content.= '<tr class="button-row"><td class="but_first_td"></td><td>'.button("continue").'</td></tr></table>';
        $content.= '</table></form></div>';
    
    break;

    //==============================================================================================
    // STEP 2.1 | Select sequence for autoincrement field only for Oracle
    //==============================================================================================

	case "2.1":
        $table = $_SESSION["db_table"];
		
		if (isset($_POST["back"]))
        {
           $_SESSION["step"] = 2;  // PREV. STEP
           header('Location: index.php');
           die();
        }
		
		if (isset($_POST["next"]))
        {
			$error_msg = '';
			if (!$_POST['sequence']) $error_msg.= LOC_INSTALL_ERR8."<br>";
            if (!$_POST['auto_inc_field']) $error_msg.= LOC_INSTALL_ERR9."<br>";
			if(!$error_msg)
			{
				$_SESSION["sequence"] = $_POST['sequence'];
				$_SESSION["auto_inc_field"] = $_POST['auto_inc_field'];
				$_SESSION["step"] = ($_SESSION["use_all_fields"]=="1") ? 4 : 3; 
				header('Location: index.php');
				die();
			}
		}
		
		$sequences = DB::getSequences($error_msg);
		
		$content = '<div id="content_step_2_1">';
		$content.= '<form action="index.php" method="POST">';
        $content.= '<table cellpadding="0" cellspacing="0">';
        $content.= '<tr><td class="first_td" width="140">&nbsp;</td><td class="second_td"><div class="message">'.LOC_SELECT_SEQ_FIELD.'</div></td></tr>';
		$content.= '<tr><td class="first_td" valign="top">'.LOC_SELECT_ID_FIELD.'</td><td><select name="auto_inc_field">';
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          $content.= '<option value="'.$_SESSION["fields"][$j].'">'.$_SESSION["fields"][$j].'</option>';
        }
		$content.= '</select></td></tr>';
		$content.= '<tr><td class="first_td" valign="top">'.LOC_SELECT_SEQ.'</td><td><select name="sequence">';
        for ($j=0; $j<sizeof($sequences); $j++)
        {
          $content.= '<option value="'.$sequences[$j].'">'.$sequences[$j].'</option>';
        }
		$content.= '</select></td></tr>';
        if ($error_msg!="")
        {
          $content.='<tr class="error_row"><td class="first_td"><div>'.LOC_ERROR.':</div></td><td><div class="error_msg"><div>'.$error_msg.'</div></div></td></tr>';
        }
        $content.= '<tr class="button-row"><td class="but_first_td">'.button("back").'</td><td class="second_td">'.button("continue").'</td></tr></table>';
		$content.= '</form></div>';
	break;
	
    //==============================================================================================
    // STEP 3
    //==============================================================================================
    
    case "3":
        $table = $_SESSION["db_table"];
        
        
        if (isset($_POST["back"]))
        {
           $_SESSION["step"] = 2;  // PREV. STEP
           header('Location: index.php');
           die();
        }

        if (isset($_POST["next"]))
        {
            $count_checked = 0;
            $_SESSION["fields_checked"][$table] = array();
            for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
            {
              $_SESSION["fields_checked"][$table][$j] = isset($_POST["field_".$j]) ? 1 : 0;
              
              // check required autoincrement field
              if ($_SESSION["fields"][$j] == $_SESSION["auto_inc_field"]) $_SESSION["fields_checked"][$table][$j] = 1;
              if ($_SESSION["fields_checked"][$table][$j]==1)
              {
                  $count_checked++;
              }
              
            }
            $_SESSION["count_checked"][$table] = $count_checked;
            
            if ($count_checked <= 1)
            {
                $error_msg.= LOC_INSTALL_ERR10."<br>";
            }
            
            // NEXT STEP
            if ($error_msg=="") 
            {
               $_SESSION["step"] = 4;
               header('Location: index.php');
               die();
            }

        }


        $content = '<div id="content_step_3">';
        $content.= '<form action="index.php" method="POST">';
        $content.= '<table cellpadding="0" cellspacing="0">';
        $content.= '<tr><td class="first_td" width="140">&nbsp;</td><td class="second_td"><div class="message">'.LOC_SELECT_FIELDS.'</div></td></tr>';
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          $class = ($j%2 == 0) ? "tr1" : "tr2";
          $attr = ($_SESSION["auto_inc_field"]==$_SESSION["fields"][$j]) ? "checked disabled" : ($_SESSION["fields_checked"][$table][$j]==1 ? "checked" : "");
          $info = ($_SESSION["auto_inc_field"]==$_SESSION["fields"][$j]) ? " (required)" : "";
          $content.= '<tr class="'.$class.'"><td class="first_td"><input name="field_'.$j.'" '.$attr.' type="checkbox"></td><td class="second_td">'.$_SESSION["fields"][$j].$info.'</td></tr>';
        }
        if ($error_msg!="")
        {
          $content.='<tr class="error_row"><td class="first_td"><div>'.LOC_ERROR.':</div></td><td><div class="error_msg"><div>'.$error_msg.'</div></div></td></tr>';
        }
        $content.= '<tr class="button-row"><td class="but_first_td">'.button("back").'</td><td class="second_td">'.button("continue").'</td></tr></table>';
        $content.= '</table>';
        $content.= '</form></div>';
    break;
    
    

    
    

    //==============================================================================================
    // STEP 4
    //==============================================================================================
    
    case "4":
        $table = $_SESSION["db_table"];
        
        
        if (isset($_POST["back"]))
        {
           $_SESSION["step"] = ($_SESSION["use_all_fields"]=="1") ? 2 : 3;
           header('Location: index.php');
           die();
        }

        if (isset($_POST["clear"]))
        {
           $_SESSION["fields_info"][$table] = array();
           header('Location: index.php');
           die();
        }    

       
        // Assign values
        $count = 0;
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          if ($_SESSION["fields_checked"][$table][$j] == 1 && $_SESSION["fields"][$j]!=$_SESSION["auto_inc_field"])
          {
              $count++;
              $_SESSION["fields_info"][$table]["name"][$j]   = isset($_POST["field_name_".$j]) ? $_POST["field_name_".$j] : (isset($_SESSION["fields_info"][$table]["name"][$j]) ? $_SESSION["fields_info"][$table]["name"][$j] : $_SESSION["fields"][$j]);
              $_SESSION["fields_info"][$table]["order"][$j]  = isset($_POST["field_order_".$j]) ? $_POST["field_order_".$j] : (isset($_SESSION["fields_info"][$table]["order"][$j]) ? $_SESSION["fields_info"][$table]["order"][$j] : $count);
              $_SESSION["fields_info"][$table]["sort"][$j]   = isset($_POST["field_sort_".$j]) ? $_POST["field_sort_".$j] : (isset($_SESSION["fields_info"][$table]["sort"][$j]) ? $_SESSION["fields_info"][$table]["sort"][$j] : "na");
              $_SESSION["fields_info"][$table]["filter"][$j] = isset($_POST["field_filter_".$j]) ? $_POST["field_filter_".$j] : (isset($_SESSION["fields_info"][$table]["filter"][$j]) ? $_SESSION["fields_info"][$table]["filter"][$j] : "na");
              $_SESSION["fields_info"][$table]["type"][$j]   = isset($_POST["field_type_".$j]) ? $_POST["field_type_".$j] : (isset($_SESSION["fields_info"][$table]["type"][$j]) ? $_SESSION["fields_info"][$table]["type"][$j] : "ro");
          }
        }


        
        if (isset($_POST["next"]))
        {
            $_SESSION["form_config_file"] = get_form_config_filename($config_dir, $_SESSION["grid_title"], $reserved_names);
            $_SESSION["form_page_file"] = str_replace(".ini", ".php", basename($_SESSION["form_config_file"]));
            $_SESSION["form_connector_file"] = str_replace(".ini", "_connector.php", basename($_SESSION["form_config_file"]));
            $_SESSION["form_log_file"] = str_replace(".ini", ".log", basename($_SESSION["form_config_file"]));
            
            $result = save_cofig($_SESSION["form_config_file"], prepare_config_data());
            if ($result!="")
            {
              $error_msg.= $result."<br>";            
            }
            

            if ($grid_page_content = file_get_contents($form_template))
            {
                $grid_page_content = str_replace("{DB_CONFIG_FILE}",   "conf/".basename($config_file), $grid_page_content);
                $grid_page_content = str_replace("{FORM_CONFIG_FILE}", "conf/".basename($_SESSION["form_config_file"]), $grid_page_content);
                $grid_page_content = str_replace("{CONNECTOR_FILE}",   basename($_SESSION["form_connector_file"]), $grid_page_content);
                $grid_page_content = str_replace("{NOT_COFIGURED}",    "YES", $grid_page_content);
                $grid_page_content = str_replace("{LOG_FILE}",         basename($_SESSION["form_log_file"]), $grid_page_content);
				$grid_page_content = str_replace("{GRID_TITLE}", $_SESSION["grid_title"], $grid_page_content);
				$grid_page_content = str_replace("{QT_URL}", substr('http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'],0,-17), $grid_page_content);
                if ($f = fopen("../".basename($_SESSION["form_page_file"]), "w"))
                {
                  fwrite($f, $grid_page_content);
                  fclose($f);
                }
                else
                {
                   $error_msg.= LOC_INSTALL_ERR11."<br>";
                }
                
            }
            else
            {
                $error_msg.= LOC_INSTALL_ERR12."<br>";
            }

            
            if ($error_msg=="") 
            {
               $_SESSION["step"] = "final";
               header('Location: index.php');
               die();
            }
        }

        $content = '<div id="content_step_4">';
        $content.= '<form action="index.php" method="POST">';
        $content.= '<table cellpadding="0" cellspacing="0">';
        $content.= '<tr><td class="first_td" width="140">&nbsp;</td><td><div class="message">'.LOC_CONFIGURE.'</div></td></tr>';
        $content.= '</table>';
        
        $content.= '<div id="configure">';
        $content.= '<table cellpadding="0" cellspacing="0">';
        $content.= '<tr class="table_header tr1"><td class="first_td" width="140"><div style="width:140px;">&nbsp;</div></td>';
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          if ($_SESSION["fields_checked"][$table][$j] == 1 && $_SESSION["fields"][$j]!=$_SESSION["auto_inc_field"])
          {
              $content.= '<td>'.$_SESSION["fields"][$j].'</td>';
          }
        }
        $content.= '</tr>';

        
        // TITLE ROW
        $content.= '<tr><td class="first_td">'.LOC_TITLE.'</td>';
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          if ($_SESSION["fields_checked"][$table][$j] == 1 && $_SESSION["fields"][$j]!=$_SESSION["auto_inc_field"])
          {
              $content.= '<td><input name="field_name_'.$j.'" value="'.htmlspecialchars($_SESSION["fields_info"][$table]["name"][$j]).'"/></td>';
          }
        }
        $content.= '</tr>';


        // ORDER ROW
        $content.= '<tr class="tr1"><td class="first_td">'.LOC_ORDER.'</td>';
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          if ($_SESSION["fields_checked"][$table][$j] == 1 && $_SESSION["fields"][$j]!=$_SESSION["auto_inc_field"])
          {
              $content.= '<td><select  name="field_order_'.$j.'">';
              for ($k=1; $k<=$_SESSION["count_checked"][$table]-1; $k++)
              {
                $content.= '<option '.($k==$_SESSION["fields_info"][$table]["order"][$j] ? "selected=\"selected\"" : "").' value="'.$k.'">'.$k.'</option>';
              }
              $content.= '</select></td>';
          }
        }
        $content.= '</tr>';


        // SORT ROW
        $content.= '<tr><td class="first_td">'.LOC_SORT.'</td>';
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          if ($_SESSION["fields_checked"][$table][$j] == 1 && $_SESSION["fields"][$j]!=$_SESSION["auto_inc_field"])
          {
              $content.= '<td><select  name="field_sort_'.$j.'">';
              foreach ($sort_values as $name => $value)
              {
                $content.= '<option '.($value==$_SESSION["fields_info"][$table]["sort"][$j] ? "selected=\"selected\"" : "").' value="'.$value.'">'.$name.'</option>';
              }
              $content.= '</select></td>';
          }
        }
        $content.= '</tr>';

        // FILTER ROW
        $content.= '<tr class="tr1"><td class="first_td">'.LOC_FILTER.'</td>';
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          if ($_SESSION["fields_checked"][$table][$j] == 1 && $_SESSION["fields"][$j]!=$_SESSION["auto_inc_field"])
          {
              $content.= '<td><select  name="field_filter_'.$j.'">';
              foreach ($filter_values as  $name => $value)
              {
                $content.= '<option '.($value==$_SESSION["fields_info"][$table]["filter"][$j] ? "selected=\"selected\"" : "").' value="'.$value.'">'.$name.'</option>';
              }
              $content.= '</select></td>';
          }
        }
        $content.= '</tr>';

        // TYPE ROW
        $content.= '<tr><td class="first_td">'.LOC_TYPE.'</td>';
        for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
        {
          if ($_SESSION["fields_checked"][$table][$j] == 1 && $_SESSION["fields"][$j]!=$_SESSION["auto_inc_field"])
          {
              $content.= '<td><select  name="field_type_'.$j.'">';
              foreach ($type_values as  $name => $value)
              {
                $content.= '<option '.($value==$_SESSION["fields_info"][$table]["type"][$j] ? "selected=\"selected\"" : "").' value="'.$value.'">'.$name.'</option>';
              }
              $content.= '</select></td>';
          }
        }
        $content.= '</tr>';


        $content.= '</table>';
        $content.= '</div>';
        
        $content.= '<table cellpadding="0" cellspacing="0">';
        if ($error_msg!="")
        {
          $content.='<tr class="error_row"><td width="140" class="first_td"><div>'.LOC_ERROR.':</div></td><td><div class="error_msg"><div>'.$error_msg.'</div></div></td></tr>';
        }
        $content.= '<tr class="button-row"><td width="140" class="but_first_td">'.button("back").'</td><td class="second_td">'.button("save").'</td></tr></table>';
        $content.= '</table>';
        $content.= '</form></div>';
    
    break;
    
  


    //==============================================================================================
    // STEP final
    //==============================================================================================
    case "final":
        
        if (isset($_POST["back"]))
        {
           $_SESSION["step"] = 4;
           header('Location: index.php');
           die();
        }

        $content = '<div id="content_step_final">';
        $content.= '<form action="index.php" method="POST">';
        $content.= '<table cellpadding="0" cellspacing="0">
        <tr><td class="first_td" width="140">&nbsp;</td><td><div class="message">'.LOC_INSTALL_MSG4.'</div></td></tr>
        <tr><td class="first_td" ></td><td>'.LOC_INSTALL_MSG5.':<br><br>
        <a href="'.$grid_root_page.$_SESSION["form_page_file"].'">'.$grid_root_page.$_SESSION["form_page_file"].'</a><br><br>
        '.LOC_INSTALL_MSG6.':<br><br>
        <a href="'.$grid_root_page.$_SESSION["form_page_file"].'?key='.$_SESSION["access_key"].'">'.$grid_root_page.$_SESSION["form_page_file"].'?key='.$_SESSION["access_key"].'</a><br><br>
        <br><br>
        <a href="'.$grid_admin_page.'?key='.$_SESSION["access_key"].'">'.LOC_BACK_TO_ADMIN_PAGE.'</a>
        
        </td></tr>';
        if ($error_msg!="")
        {
          $content.='<tr class="error_row"><td class="first_td"><div>'.LOC_ERROR.':</div></td><td><div class="error_msg"><div>'.$error_msg.'</div></div></td></tr>';
        }
        //$content.= '<tr class="button-row"><td class="but_first_td">'.button("back").'</td><td></td></tr></table>';
        $content.= '</table></form></div>';
        $_SESSION = array();
        unset($_SESSION);
    
    break;

}



?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
 <head>
  <title><?php echo $title; ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <link rel="stylesheet" type="text/css" href="install.css" />
  <?php if ($script):?><script type="text/javascript"><?php echo $script?></script><?php endif;?>
 </head>
<body>
<center>
<div id="install_main">
  <div id="install_header">
    <div id="install_header_left"></div>
    <div id="install_header_right"></div>
  </div>
  <div id="install_content"><?php echo $content; ?></div>
</div>
</center>
<?php echo $dbg; ?>
</body>
</html>
